#include "hmg.ch"

Procedure Report_a

   SET BROWSESYNC ON
   SET NAVIGATION EXTENDED

   SET DATE GERMAN // for test
   SET CENTURY ON  // for test

   *SET procedure to open_dbf // for test
   *SET procedure to open_ntx // for test
   *SET procedure to use_dbf // for test

   open_dbf() // for test
   open_ntx() // for test

   DEFINE WINDOW Rep_1 ;
      AT 0, 0 ;
      WIDTH 400 ;
      HEIGHT 400 ;
      TITLE "REPORT" ;
      MODAL ;

      ON KEY ESCAPE ACTION Rep_1.Release 


   @ 150, 150 BUTTON PRINT_6402 ;
      CAPTION " Create report " ;
      ACTION rep_create_6402() ;
      WIDTH 100

   END WINDOW

   Rep_1.CENTER
   ACTIVATE WINDOW Rep_1

RETURN
*----------------------------------------*
PROCEDURE rep_create_6402

PRIVATE mPrinter, nCurLine:=300, nCurPage:=0, nPageSize:=280, /* := 180 */ nVMargin:=10, nHMargin:=10 
PRIVATE cFontName:="Verdana", nFontSize:=8, nFontHeight:=4, nCharWidth:=2 

pre_rep1()

USE_REPORT()   // function from USE_DBF.prg 

sumr_03 := 0 
sumr_04 := 0 

   mPrinter := GetPrinter()
   IF Empty ( mPrinter )
      MsgExclamation( "Printer not selected" )
      dbcloseall()
      RETURN NIL
   ENDIF

   SELECT PRINTER mPrinter ;
      ORIENTATION PRINTER_ORIENT_PORTRAIT ;  // PRINTER_ORIENT_LANDSCAPE ; 
      PAPERSIZE PRINTER_PAPER_A4 ;
      PREVIEW 

   START PRINTDOC NAME "report" 

DBGOTOP()
DO WHILE .NOT. EOF()

sumr_03 := sumr_03 + EXPENSE   
sumr_04 := sumr_04 + PAYMENT   

   IF nCurLine > nPageSize
      hdr_6402()
   ENDIF

   nCurLine += nFontHeight
   nCurCol = nHMargin + 1 * nCharWidth + 3 * nCharWidth 
   @ nCurLine, nCurCol PRINT  TRANSFORM ( PAY_ID, "999") FONT cFontName SIZE nFontSize RIGHT
   nCurCol = nHMargin + 5 * nCharWidth
   @ nCurLine, nCurCol PRINT  TRANSFORM ( PAYDESC, "XXXXXXXXXXXXXXXXXXXX") FONT cFontName SIZE nFontSize
   nCurCol = nHMargin + 26 * nCharWidth + 10 * nCharWidth 
   @ nCurLine, nCurCol PRINT  TRANSFORM ( EXPENSE, "9999999.99") FONT cFontName SIZE nFontSize RIGHT
   nCurCol = nHMargin + 37 * nCharWidth + 10 * nCharWidth 
   @ nCurLine, nCurCol PRINT  TRANSFORM ( PAYMENT, "9999999.99") FONT cFontName SIZE nFontSize RIGHT
   nCurCol = nHMargin + 48 * nCharWidth + 10 * nCharWidth 
   @ nCurLine, nCurCol PRINT  TRANSFORM ( SALDO, "9999999.99") FONT cFontName SIZE nFontSize RIGHT

   DBSKIP()
ENDDO
nCurLine += nFontHeight

nCurLine += nFontHeight
nCurCol = nHMargin + 26 * nCharWidth
nCurCol2 = nCurCol + 10 * nCharWidth
@ nCurLine+2, nCurCol PRINT LINE TO nCurLine+2, nCurCol2 PENWIDTH .5
nCurCol = nHMargin + 37 * nCharWidth
nCurCol2 = nCurCol + 10 * nCharWidth
@ nCurLine+2, nCurCol PRINT LINE TO nCurLine+2, nCurCol2 PENWIDTH .5

nCurLine += nFontHeight
nCurCol = nHMargin + 26 * nCharWidth + 10 * nCharWidth 
@ nCurLine, nCurCol PRINT  TRANSFORM ( sumr_03, "9999999.99") FONT cFontName SIZE nFontSize BOLD RIGHT
nCurCol = nHMargin + 37 * nCharWidth + 10 * nCharWidth 
@ nCurLine, nCurCol PRINT  TRANSFORM ( sumr_04, "9999999.99") FONT cFontName SIZE nFontSize BOLD RIGHT

   END PRINTPAGE
END PRINTDOC

DBCLOSEALL()

Rep_1.RELEASE

RETURN 0
*----------------------------------------*
FUNCTION hdr_6402

nCurPage++
nCurLine := nVMargin

IF nCurPage > 1
   END PRINTPAGE
ENDIF

   START PRINTPAGE

@ nCurLine, 10 PRINT "Date : " + DTOC(date()) FONT cFontName SIZE nFontSize // BOLD
@ nCurLine, 180 PRINT "Page : " + STR(nCurPage, 3) FONT cFontName SIZE nFontSize // BOLD
@ nCurLine, 100 PRINT "TITLE of Report" FONT cFontName SIZE nFontSize+2 CENTER BOLD
nCurLine += nFontHeight

nCurLine += nFontHeight
nCurCol = nHMargin + 1 * nCharWidth + 3 * nCharWidth
@ nCurLine, nCurCol PRINT "PAY" FONT cFontName SIZE nFontSize RIGHT BOLD
nCurCol = nHMargin + 5 * nCharWidth
@ nCurLine, nCurCol PRINT "PAYDESC" FONT cFontName SIZE nFontSize BOLD
nCurCol = nHMargin + 26 * nCharWidth + 10 * nCharWidth
@ nCurLine, nCurCol PRINT "EXPENSE" FONT cFontName SIZE nFontSize RIGHT BOLD
nCurCol = nHMargin + 37 * nCharWidth + 10 * nCharWidth
@ nCurLine, nCurCol PRINT "PAYMENT" FONT cFontName SIZE nFontSize RIGHT BOLD
nCurCol = nHMargin + 48 * nCharWidth + 10 * nCharWidth
@ nCurLine, nCurCol PRINT "SALDO" FONT cFontName SIZE nFontSize RIGHT BOLD

nCurLine += nFontHeight
nCurCol = nHMargin + 1 * nCharWidth
nCurCol2 = nCurCol + 3 * nCharWidth
@ nCurLine+2, nCurCol PRINT LINE TO nCurLine+2, nCurCol2 PENWIDTH .5
nCurCol = nHMargin + 5 * nCharWidth
nCurCol2 = nCurCol + 20 * nCharWidth
@ nCurLine+2, nCurCol PRINT LINE TO nCurLine+2, nCurCol2 PENWIDTH .5
nCurCol = nHMargin + 26 * nCharWidth
nCurCol2 = nCurCol + 10 * nCharWidth
@ nCurLine+2, nCurCol PRINT LINE TO nCurLine+2, nCurCol2 PENWIDTH .5
nCurCol = nHMargin + 37 * nCharWidth
nCurCol2 = nCurCol + 10 * nCharWidth
@ nCurLine+2, nCurCol PRINT LINE TO nCurLine+2, nCurCol2 PENWIDTH .5
nCurCol = nHMargin + 48 * nCharWidth
nCurCol2 = nCurCol + 10 * nCharWidth
@ nCurLine+2, nCurCol PRINT LINE TO nCurLine+2, nCurCol2 PENWIDTH .5


RETURN 0
*:--------------------------------------------------
function pre_rep1

use_cost()

use_report()
zap

use_payment()

do while .not. eof()

   _pay_id = pay_id
   _expense = expense
   _payment = payment

   select cost
   seek _pay_id
   _paydesc = descript

   select report
   seek _pay_id
   if !found()
      dbappend()
      replace pay_id with _pay_id
      replace paydesc with _paydesc
      replace expense with _expense
      replace payment with _payment
   else
      replace expense with expense + _expense
      replace payment with payment + _payment
   endif

   select payment
   dbskip()
enddo

select report
replace saldo with expense - payment all

dbcloseall()

return
